#!/bin/bash

echo 1234567890 > digit.txt    # Write string of digits to "digits.txt".
exec 3<> digit.txt                 # Open "digit.txt" for reading and writing
                               # and assign fd 3 to it.
read -n 4 <&3                  # Read only 4 characters. This moves the file descriptor
                               # to the position behind the 4th digit
echo . >&3                  # Write a decimal point there.
exec 3>&-                      # Close fd 3.
cat digit.txt                  # should print 1234.67890