#!/bin/bash

# This script computes a very rough approximation of pi
# Remember: $RANDOM gives 0-32767

ITERATIONS=10000
SUCCESS=0

for i in `seq 1 $ITERATIONS`; do
    X=$(echo "scale=10; $RANDOM / 32767.0" | bc) 
    Y=$(echo "scale=10; $RANDOM / 32767.0" | bc) 
    DISTANCE=$(echo "scale=10; $X * $X + $Y * $Y" | bc)
    
    if [ $(echo " $DISTANCE < 1.0" | bc) -eq 1 ]
    then
        let SUCCESS=SUCCESS+1
    fi
done

PI=$(echo "scale=10; 4.0 * $SUCCESS / $ITERATIONS" | bc)

echo $PI
